#! /usr/local/bin/apl --script
 ⍝ ********************************************************************
 ⍝   $Id: $
 ⍝ $desc: Library for a component file based lexicon $
 ⍝ ********************************************************************

)copy 1 lex

)copy 5 ComponentFiles

cl∆∆max←20			⍝ Maxmimum count of items for cl∆values
cl∆∆db_type←'postgresql'
cl∆∆db_spec←'host=localhost user=dalyw password=BzGX8JfHar dbname=apl_comp'

⍝ Connect to postgres server for access to component files
cl∆∆db_type CF_DBCONNECT cl∆∆db_spec

∇toc←cl∆keys fh
 ⍝ Function to display the table of contents of a component store
 toc←CF_READ fh,1
∇

∇fh←cl∆init fname;toc;rec
 ⍝ Function initiates a component store
 toc ← lex∆init
 ⍎(CF_FILEEXISTS fname)/'⍞←fname'' Exists''◊→0'
 fh←CF_CREATE fname
 rec←toc CF_APPEND fh
∇

∇fh cl∆assign val;toc;rec
 ⍝ Function to post a new component to the component store
 ⍎(2≠⎕nc 'fh')/'⍞←''An open component file should be supplied as a left argument'''
 toc←CF_READ fh,1
 rec←(⊃val[2])CF_APPEND fh
 toc←toc lex∆assign (⊂⊃val[1]),⊂rec
 toc CF_WRITE fh,1
∇

∇dat←fh cl∆lookup key;rec
 ⍝ Function retrieves a component from a component store and
 ⍝ establishes it in the database.
 toc←CF_READ fh,1
 rec←toc lex∆lookup key
 dat←CF_READ fh,rec
∇

∇b←cl∆is fh;toc
  ⍝ Function tests if fh handle points to a component based lexicon.
  'b←0◊→0' ⎕EA 'toc←CF_READ fh,1'
  b←lex∆is toc
∇

∇msg←cl∆values fh;lb;i;⎕io
  ⍝ Returns all the values is a component base lexicon up to cl∆∆max
  ⍝ items and get obnoxious for large component files.
  ⎕io←1
  toc←CF_READ fh,1
  →(cl∆∆max<1↑⍴toc)/oh_well
  lb←((1↑⍴toc)⍴st),end
  i←1
  msg←0⍴0
st:
  msg←msg,⊂CF_READ fh,toc[i;2]
  →lb[i←i+1]
end:
  →0
oh_well:
  msg←'I''m balking on this one as file is too large.'
  →0
∇

∇Z←lex⍙metadata
Z←0 2⍴⍬
Z←Z⍪'Author'          'Bill Daly'
Z←Z⍪'BugEmail'        'bugs@dalywebandedit.com'
Z←Z⍪'Documentation'   'cl.txt'
Z←Z⍪'Download'        'https://sourceforge.net/p/apl-library/code/ci/master/tree/cl.apl'
Z←Z⍪'License'         'GPL v3.0'
Z←Z⍪'Portability'     'L3'
Z←Z⍪'Provides'        ''
Z←Z⍪'Requires'        ''
Z←Z⍪'Version'         '0 0 1'
∇
