#!/usr/local/bin/apl --script

⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝
⍝
⍝ xml 2016-08-31 09:29:08 (GMT-5)
⍝
⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝

⍝ xml, a workspace to create xml schmeas
⍝ Copyright (C) 2016  Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.



)copy 1 lex
)copy 1 util_min

∇attr←key xml∆lex2attr value
  ⍝ Fn to prepare thes text of an element's attribute from the key and value
  →(util∆numberp value)/numeric
text:
  attr←(util∆trim key),'="',(util∆trim value),'"'
  →0
numeric:
  attr←(util∆trim key),'="',(⍕''⍴value),'"'
  →0
∇

∇rs←prefix xml∆MkTagFns tag;txt
  ⍝ Function to create a tag function
  txt←⊂'txt←attr ',prefix,'∆',tag,' val'
  txt←txt,⊂'⍝ Function returns a ',tag,' tag'
  txt←txt,⊂'⍎(2≠⎕nc ''attr'')/''attr←lex∆init'''
  txt←txt,⊂'txt←(attr xml∆start ''',tag,'''),val,xml∆end ''',tag,''''
  rs←⎕fx txt
∇

∇rs←prefix xml∆MkClosedTagFns tag;txt
  ⍝ Function to create a closed tag function
  txt←⊂'txt←',prefix,'∆',tag,' attr'
  txt←txt,⊂'⍝ Function returns a closed ',tag,' tag'
  txt←txt,⊂'txt←attr xml∆closed ''',tag,''''
  rs←⎕fx txt

∇
∇elm←attr xml∆closed tag
  ⍝ Function to create a closed element
  ⍎(2≠⎕nc 'attr')/'attr←lex∆init'
  elm←'<',tag, ∊(' ',¨attr[;1] xml∆lex2attr¨ attr[;2]),'/>'
∇

∇elm←xml∆end tag
  ⍝ Function returnss an ending xml element tag
  elm←'</',tag,'>'
∇

∇elm←attr xml∆start tag
  ⍝ Function to assemble the start tag of an xml element.
  ⍎(2≠⎕nc 'attr')/'attr←lex∆init'
  elm←'<',tag,∊(' ',¨attr[;1] xml∆lex2attr¨ attr[;2]),'>'
∇

∇rule←xml∆mkRule l
 ⍝ Function to create a cascading style sheet rule from a lexicon
 rule←⎕av[11] util∆join {(⍵,': '),(l lex∆lookup ⍵),';'}¨lex∆keys l
∇

∇sheet←xml∆mkSheet l
 ⍝ Functio to assemble a style sheet from a lexicon of selectors and rules.
 sheet←⎕av[11] util∆join {⍵,' {',⎕av[11],(xml∆mkRule l lex∆lookup ⍵),⎕av[11],'}'}¨lex∆keys l
∇

∇lex←xml∆parse txt;a;lb
   ⍝ Function to parse a cascading stylesheet and return a nested lexicon
   txt←util∆reduce∆whitespace txt
   lex←lex∆init
   →(0=⍴⍴a←'{' util∆split ¨ ¯1↓ '}' util∆split txt)/0
   lb←((⍴a)⍴st),0
   i←1
 st:
   lex←lex lex∆assign (⊂util∆trim ⊃(⊃a[i])[1]),⊂xml∆parseRule ⊃(⊃a[i])[2]
   →lb[i←i+1]
∇

∇rule←xml∆parseRule txt;lb;i
   ⍝ Function to parse the rule portion of a cascading style and return
   ⍝ a lexicon of properties and settings
   rule←lex∆init
   txt←':'util∆split ¨ ¯1↓';' util∆split txt
   lb←((⍴txt)⍴st),0
   i←1
 st:
   rule←rule lex∆assign ⊃txt[i]
   →lb[i←i+1]
∇

html5∆closedTagList←3⍴0
((⎕IO+0)⊃html5∆closedTagList)←2⍴'br'
((⎕IO+1)⊃html5∆closedTagList)←2⍴'hr'
((⎕IO+2)⊃html5∆closedTagList)←4⍴'meta'

html5∆tagList←34⍴0
html5∆tagList[0+⍳34]←'a∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘'
((⎕IO+1)⊃html5∆tagList)←1⍴'b'
((⎕IO+2)⊃html5∆tagList)←10⍴'blockquote'
((⎕IO+3)⊃html5∆tagList)←4⍴'body'
((⎕IO+4)⊃html5∆tagList)←7⍴'caption'
((⎕IO+5)⊃html5∆tagList)←4⍴'cite'
((⎕IO+6)⊃html5∆tagList)←3⍴'div'
((⎕IO+7)⊃html5∆tagList)←2⍴'em'
((⎕IO+8)⊃html5∆tagList)←6⍴'footer'
((⎕IO+9)⊃html5∆tagList)←2⍴'h1'
((⎕IO+10)⊃html5∆tagList)←2⍴'h2'
((⎕IO+11)⊃html5∆tagList)←2⍴'h3'
((⎕IO+12)⊃html5∆tagList)←2⍴'h4'
((⎕IO+13)⊃html5∆tagList)←2⍴'h5'
((⎕IO+14)⊃html5∆tagList)←4⍴'head'
((⎕IO+15)⊃html5∆tagList)←6⍴'header'
((⎕IO+16)⊃html5∆tagList)←2⍴'hr'
((⎕IO+17)⊃html5∆tagList)←4⍴'html'
((⎕IO+18)⊃html5∆tagList)←1⍴'i'
((⎕IO+19)⊃html5∆tagList)←2⍴'li'
((⎕IO+20)⊃html5∆tagList)←4⍴'link'
((⎕IO+21)⊃html5∆tagList)←3⍴'nav'
((⎕IO+22)⊃html5∆tagList)←1⍴'p'
((⎕IO+23)⊃html5∆tagList)←3⍴'pre'
((⎕IO+24)⊃html5∆tagList)←4⍴'span'
((⎕IO+25)⊃html5∆tagList)←6⍴'strong'
((⎕IO+26)⊃html5∆tagList)←5⍴'style'
((⎕IO+27)⊃html5∆tagList)←2⍴'td'
((⎕IO+28)⊃html5∆tagList)←2⍴'th'
((⎕IO+29)⊃html5∆tagList)←5⍴'thead'
((⎕IO+30)⊃html5∆tagList)←2⍴'tr'
((⎕IO+31)⊃html5∆tagList)←5⍴'title'
((⎕IO+32)⊃html5∆tagList)←5⍴'table'
((⎕IO+33)⊃html5∆tagList)←5⍴'thead'


∇Z←xml⍙metadata
  Z←0 2⍴⍬
  Z←Z⍪'Author'          'Bill Daly'
  Z←Z⍪'BugEmail'        'bugs@dalywebandedit.com'
  Z←Z⍪'Documentation'   'lex.txt'
  Z←Z⍪'Download'        'https://sourceforge.net/p/apl-library/code/ci/master/tree/xml.apl'
  Z←Z⍪'License'         'GPL v3.0'
  Z←Z⍪'Portability'     'L1'
  Z←Z⍪'Provides'        ''
  Z←Z⍪'Requires'        ''
  Z←Z⍪'Version'         '0 0 1'
∇
